--- u-boot-1.1.1-orig/cpu/mips/start.S	2004-02-06 19:27:17.000000000 -0600
+++ u-boot/cpu/mips/start.S	2005-09-12 09:06:50.623490000 -0500
@@ -234,23 +234,44 @@
 	li	t0, CONF_CM_UNCACHED
 	mtc0	t0, CP0_CONFIG
 
+	/* Initialize GOT pointer.
+	 */
+	bal	1f
+	nop
+	.extern	_GLOBAL_OFFSET_TABLE_
+	.word	_GLOBAL_OFFSET_TABLE_
+	.word	. - 4
+	/* .word	_GLOBAL_OFFSET_TABLE_ - 1f + 4 */
+1:
+	move	gp, ra
+	lw	t1, 0(ra)
+	lw	t2, 4(ra)
+	sub	t1, t2
+	add	gp, t1	# calculate current location of offset table
+
 #ifdef CONFIG_INCA_IP
 	/* Disable INCA-IP Watchdog.
 	 */
-	bal	disable_incaip_wdt
+	jal	disable_incaip_wdt
 	nop
 #endif
 
+
 	/* Initialize any external memory.
 	 */
-	bal	memsetup
+	.extern	memsetup
+	jal	memsetup
 	nop
 
+
 	/* Initialize caches...
 	 */
-	bal	mips_cache_reset
+	.extern	mips_cache_reset
+	jal	mips_cache_reset
 	nop
 
+	DEBUG_HEX_ASM(2)
+
 	/* ... and enable them.
 	 */
 	li	t0, CONF_CM_CACHABLE_NONCOHERENT
@@ -259,24 +280,23 @@
 
 	/* Set up temporary stack.
 	 */
-	li	a0, CFG_INIT_SP_OFFSET
-	bal	mips_cache_lock
+	.extern	mips_cache_lock
+	jal	mips_cache_lock
+	li	a0, CFG_INIT_SP_OFFSET	/* stack is set from arg
+
+	DEBUG_HEX_ASM(4)
+#if defined( CONFIG_AU1200 )
+	.extern enable_uart0
+	jal	enable_uart0
 	nop
+#endif /* defined( CONFIG_AU1200 ) */
 
 	li	t0, CFG_SDRAM_BASE + CFG_INIT_SP_OFFSET
 	la	sp, 0(t0)
 
-	/* Initialize GOT pointer.
-	 */
-	bal	1f
-	nop
-	.word	_GLOBAL_OFFSET_TABLE_ - 1f + 4
-1:
-	move	gp, ra
-	lw	t1, 0(ra)
-	add	gp, t1
-	la	t9, board_init_f
-	j	t9
+	DEBUG_HEX_ASM(5)
+	.extern	board_init_f
+	jal	board_init_f
 	nop
 
 
@@ -345,7 +365,7 @@
 	 */
 	lw	t3, -4(t0)	/* t3 <-- num_got_entries	*/
 	addi	t4, gp, 8	/* Skipping first two entries.	*/
-	li	t2, 2
+	li	t2, 3		/* 2+1 skip two and start with one */
 1:
 	lw	t1, 0(t4)
 	beqz	t1, 2f
@@ -381,5 +401,18 @@
 romReserved:
 	b romReserved
 
+	.extern	wb
 romExcHandle:
+#if defined( CONFIG_AU1200 )
+	DEBUG_HEX_ASM(0xec)
+	jal	wb
+	li	a0, 'e'
+	jal	wb
+	li	a0, 'x'
+#endif /* defined( CONFIG_AU1200 ) */
+
+1:
+	b	1b
+	nop
 	b romExcHandle
+
